PREDICATES
  get_level(STRING,STRING,STRING,INTEGER,INTEGER)
  get_groupe(STRING,STRING)
  get_lang(STRING)
  init_var_cpl(STRING,STRING,INTEGER,INTEGER,STRING)
  init_visite1(STRING,STRING,INTEGER,INTEGER,STRING)

CLAUSES
  init_visite(SOB,PROF,SRAN) :-
  	load_profil(SOB),
        get_level(SOB,PROF,SRAN,LEVEL,RANGE),
        get_groupe(SOB,GROUPE),
        get_lang(LANGUE),
        init_visite1(SOB,GROUPE,LEVEL,RANGE,LANGUE).

  init_visite1(SOBRIQUET,GROUPE,LEVEL,RANGE,LANGUE) :-
% traiter fichier de la session d'avant
% insertion des infos dans le fichier gnral
% ouverture d'un fichier de session (traiter  une nouvelle ouverture de session
% reprise du send_page_partie1
        query_argument("partie",LIEU),
        query_argument("floor",FLOOR),
        query_argument("zone",ZONE),
        query_argument("dir",ORIEN),!,
        str_int(FLOOR,DOM),
        str_int(ZONE,SDOM),

	entete_http(),
	begin_entete("hall-0-0-N"),
	write("<SCRIPT LANGUAGE=\"JavaScript\">\n"),

        affiche_script(LIEU,DOM,SDOM,0,ORIEN,LEVEL,SOBRIQUET),

        init_var_cpl(SOBRIQUET,GROUPE,LEVEL,RANGE,LANGUE),

	write("</SCRIPT>\n"),

	affiche_style(LIEU,DOM,SDOM),

	write("</HEAD>\n"),	
	write("<BODY>\n"), 
 
 	affiche_body(LIEU,DOM,SDOM,ORIEN,LEVEL,SOBRIQUET),

	write("</BODY>\n</HTML>"),
	log_append(SOBRIQUET,"Entree").

  init_var_cpl(SOB,_,_,_,_) :-
	write("parent.wxSobriquet = \"",SOB,"\" ;\n"),
	fail.
  init_var_cpl(_,GROUPE,_,_,_) :-
	write("parent.wxGroupe = \"",GROUPE,"\" ;\n"),
	fail.
  init_var_cpl(_,_,_,_,_) :-
	query_argumenti("suivi","yes"),
	write("parent.wxSuivi = true ;\n"),
	fail.
  init_var_cpl(_,_,LEV,_,_) :-
	write("parent.wxLevel = ",LEV," ;\n"),
	fail.
  init_var_cpl(_,_,_,RANGE,_) :-
	write("parent.wxRange = ",RANGE," ;\n"),
	fail.
  init_var_cpl(_,_,_,_,LANG) :-
	write("parent.wxLangue = \"",LANG,"\" ;\n"),
	fail.
  init_var_cpl(_,_,_,_,_).


  edit_profil(_).

  inscript_proc("",_) :- !,
	MSG="Sobriquet vide!",
	error_new(MSG),
	fail.
  inscript_proc(SOB,_) :-
	sob_psw(SOB,_,_PSW),!,
  	format(MSG,"Le sobriquet % est d&eacute;j&agrave; utilis&eacute;",SOB),
  	error_new(MSG),
  	fail.
  inscript_proc(SOB,PSW) :-
 	query_argument("groupe",GROUPE),
 	query_argument("level",PROFIL),
 	query_argument("range",SRAN),
  	query_argument("nom",NOM),
  	query_argument("langue",LANG),
	controle_groupe(GROUPE),!,
	str_int(PROFIL,NIVEAU),
	str_int(SRAN,RANGE),
	assertz(profil(SOB,GROUPE,"",NIVEAU,RANGE),data),
	assertz(langue(LANG),data),
	assertz(name(NOM),data),
	assertz(sob_psw(SOB,GROUPE,PSW),psw),
	save_profil(SOB),
	load_groupe(GROUPE),
	assertz(est_membre(SOB,""),group),
	save_groupe(GROUPE),
	init_visite1(SOB,GROUPE,NIVEAU,RANGE,LANG).
  inscript_proc(_,_) :-
  	MSG="Le groupe indiqu&eacute; n'existe pas. Faites une demande pour le cr&eacute;er !",
  	error_new(MSG),
  	fail.

% ajouter un bienvenue

  controle_psw("","") :- !.
  controle_psw(SOB,PSW) :-
	sob_psw(SOB,_,PSW),!.
  controle_psw(SOB,_) :-
	sob_psw(SOB,_,_),!,
	format(MSG,"Mauvais mot de passe pour %",SOB),
	error_new(MSG),
	fail.
  controle_psw(SOB,_) :-
	format(MSG,"Il n'y a pas d'utilisateur inscrit avec le sobriquet %",SOB),
	error_new(MSG),
	fail.

  get_lang(LANG) :-
  	langue(LANG),!.
  get_lang("fr").

  get_level("",_,_,0,0) :- !.
  get_level(SOB,"def","def",NIV,RAN) :-
	profil(SOB,_,_,NIV,RAN),!.
  get_level(SOB,PROFIL,"def",NIV,RAN) :-
	str_int(PROFIL,NIV),
	profil(SOB,_,_,_,RAN),!.
  get_level(SOB,"def",SRAN,NIV,RAN) :-
	str_int(SRAN,RAN),
	profil(SOB,_,_,NIV,_),!.
  get_level(_SOB,PROFIL,SRAN,NIV,RAN) :-
	str_int(PROFIL,NIV),
	str_int(SRAN,RAN).

  get_groupe(SOB,GROUPE) :-
	profil(SOB,GROUPE,_,_,_),!.
  get_groupe(_,"").
