/*****************************************************************************

		Copyright (c) 1999 IRDP

 Project:  SSHOW
 FileName: UTIL_FILE.PRO
 Purpose: Simple Show (revues)
 Written by: L.-O. Pochon
 Comments:
******************************************************************************/

include "wxgoto.inc"

CLAUSES
  load_data(IDENT) :-
  	path_data(PATH),
  	format(MSG,"Probl&egrave;me avec le fichier de %",IDENT),
  	format(FILE,"%/%.pro",PATH,IDENT),
  	trap(consult(FILE,tables_pp),E,error_handler(MSG,E)),!.

  load_rela(IDENT) :-
  	path_data(PATH),
  	format(MSG,"Probl&egrave;me avec le fichier de %",IDENT),
  	format(FILE,"%/%.pro",PATH,IDENT),
  	trap(consult(FILE,tables_adj),E,error_handler(MSG,E)),!.

  load_index(IDENT) :-
  	path_data(PATH),
  	format(MSG,"Probl&egrave;me avec le fichier de %",IDENT),
  	format(FILE,"%/%.lex",PATH,IDENT),
  	trap(consult(FILE,tables_aux),E,error_handler(MSG,E)),!.
  	
/*  save_data(IDENT) :-
  	format(FILE,"%/%.pro",path_data,IDENT),
  	save(FILE,data).

  load_psw(IDENT) :-
	path_data(PATH),
  	MSG = "Probl&egrave;me avec le fichier des mots de passe",
  	format(FILE,"%/%.psw",PATH,IDENT),
  	trap(consult(FILE,psw),E,error_handler(MSG,E)),!.
  	
  save_psw(IDENT) :-
  	format(FILE,"%/%.psw",path_data,IDENT),
  	save(FILE,psw).
*/

  load_profil("") :- !.
  load_profil(IDENT) :-
  	path_data(PATH),
  	format(MSG,"Probl&egrave;me avec le fichier de %",IDENT),
  	format(FILE,"%/%.pro",PATH,IDENT),
  	trap(consult(FILE,data),E,error_handler(MSG,E)),!.
  	
  save_profil(IDENT) :-
  	path_data(PATH),!,
  	format(FILE,"%/%.pro",PATH,IDENT),
  	save(FILE,data).

  load_groupe("") :- !.
  load_groupe(IDENT) :-
  	path_data(PATH),
  	format(MSG,"Probl&egrave;me avec le fichier de %",IDENT),
  	format(FILE,"%/%.cla",PATH,IDENT),
  	trap(consult(FILE,group),E,error_handler(MSG,E)),!.

  save_groupe("") :- !.
  save_groupe(IDENT) :-
  	path_data(PATH),!,
  	format(FILE,"%/%.cla",PATH,IDENT),
  	save(FILE,group).

  load_psw(IDENT) :-
  	path_data(PATH),
  	MSG = "Probl&egrave;me avec le fichier des mots de passe",
  	format(FILE,"%/%.psw",PATH,IDENT),
  	trap(consult(FILE,psw),E,error_handler(MSG,E)),!.
  	
  save_psw(IDENT) :-
  	path_data(PATH),!,
  	format(FILE,"%/%.psw",PATH,IDENT),
  	save(FILE,psw).

  load_config() :-
%	initsyspath(),
%  	syspath(PATH,_),!,
	PATH="",
  	concat(PATH,"webexp.cnf",CNF),
  	format(MSG,"Probl&egrave;me avec le fichier de configuration %",CNF),
  	trap(consult(CNF,config),E,error_handler(MSG,E)),!.

  log_append("",MSG) :- !,
	log_append("log_visiteur",MSG).
  log_append(IDENT,MSG) :-
  	path_data(PATH),!,
  	format(FILE,"%/suivi/%.log",PATH,IDENT),
 	date(JJ,MM,YY),
	openappend(tracefile,FILE),
	writedevice(tracefile),
	format(MSG1,"%/%/% - %",JJ,MM,YY,MSG),
	write(MSG1),nl,
	closefile(tracefile).

  open_base() :-
  	db_open(myhba,"webmath.hba",in_file),
  	bt_open(myhba,"cle",IKEY),
  	bt_open(myhba,"nom",INOM),
  	bt_open(myhba,"file",IFILE),
	asserta(index_key(IKEY,INOM,IFILE)).
	
 close_base() :-
	retract(index_key(IKEY,INOM,IFILE)),
 	bt_close(myhba,IKEY),
 	bt_close(myhba,INOM),
 	bt_close(myhba,IFILE),
 	db_close(myhba).

 controle_groupe("") :- !.
 controle_groupe(GR) :-
 % fichier du groupe existe-t-il ?
 	path_data(PATH),!,
 	format(GR1,"%/%.cla",PATH,GR),
	existfile(GR1).
/*
  existdir(DIR):-
  	concat(DIR,"/.",THEDIR),
  	existfile(THEDIR). */
  
/*
  load_titre(IDENT) :-
  	format(MSG,"Probl&egrave;me avec le fichier de %",IDENT),
  	format(FILE,"%/%.pro",path_data,IDENT),
  	trap(consult(FILE,titre),E,error_handler(MSG,E)),!.
  	
  save_titre(IDENT) :-
  	format(FILE,"%/%.pro",path_data,IDENT),
  	save(FILE,titre).
  */
/*  
  access_ok(INTEGER)
  access_lock()
  access_open()
*/   
/* 
 % lock
CLAUSES
  access_lock() :-
  	openwrite(fichier,fcontro),
  	closefile(fichier).
  	
  access_open() :-
  	deletefile(fcontro),!.

  access_ok(_) :-
  	not(existfile(fcontro)),!.
  access_ok(5) :- !,
  	change_erreur("Serveur occup&eacute;. Essayez dans un petit moment !"),
  	fail.
  access_ok(N) :-
  	sleep(100),
  	N1=N+1,!,
  	access_ok(N1).
*/   	