% envoi d'une salle (frame)
PREDICATES
  make_adj_list(STRING,INTEGER,INTEGER,INTEGER,INTEGER,STRING sobriquet)
  nondeterm adj_list(STRING cadre,INTEGER dom,INTEGER sdom,INTEGER sujet, INTEGER lev,STRING sob,STRING, INTEGER,INTEGER,INTEGER,STRING titre)
  make_adj_act(STRING,INTEGER,INTEGER,INTEGER,IDENT,INTEGER)
  make_act_all(STRING,INTEGER,INTEGER,INTEGER,IDENT,INTEGER)
  make_url(IDENT,STRING)
  send_frame_salle3(SYMBOL,INTEGER,INTEGER,INTEGER,IDENT,INTEGER,STRING)
  send_frame_salle31(STRING path,SYMBOL,INTEGER,INTEGER,INTEGER,IDENT,INTEGER,STRING)
  bool_sortie(SYMBOL,INTEGER,INTEGER,INTEGER,STRING)
  first_activity(SYMBOL cadre,INTEGER dom, INTEGER sdom,INTEGER sujet,INTEGER level,IDENT,INTEGER outlevel)
  get_interface(SYMBOL cadre,INTEGER dom,INTEGER sdom,INTEGER sujet,INTEGER code,STRING,STRING,STRING)

  send_script_salle(SYMBOL cadre, INTEGER dom, INTEGER sdom,INTEGER sujet, IDENT,INTEGER level,STRING sobriquet)

CLAUSES
% le name est fix
  send_frame_fsalle(CADRE,DOM,SDOM,SUJET,LEVEL,SOBRIQUET) :- % sobriquet pour trace !
  	query_argument("name",NAME),
  	NAME<>"",!,
	send_frame_salle3(CADRE,DOM,SDOM,SUJET,NAME,LEVEL,SOBRIQUET).
% on prend la premire activit disponible 
  send_frame_fsalle(CADRE,DOM,SDOM,SUJET,LEVEL,SOBRIQUET) :- % sobriquet pour trace !
	first_activity(CADRE,DOM,SDOM,SUJET,LEVEL,NAME,_),
	send_frame_salle3(CADRE,DOM,SDOM,SUJET,NAME,LEVEL,SOBRIQUET).
% donne par son nom (unique !) seulement
% problme du choix de la salle
  send_frame_fsalle2(NAME,LEVEL,SOBRIQUET) :- % sobriquet pour trace !
  % il peut y avoir une demande sur une activit de visibilit 0 !
  % la demande est faite sur le nom, on ne peut refuser un LEVEL !
	get_ui(_,_PACK,_FILE,NAME,_TITRE,CADRE,DOM,SDOM,SUJET,_TYPE,100,_),!,
	send_frame_salle3(CADRE,DOM,SDOM,SUJET,NAME,LEVEL,SOBRIQUET).

  send_frame_salle3(CADRE,DOM,SDOM,SUJET,NAME,LEVEL,SOBRIQUET) :-
	entete_http(),
	begin_entete_frame(NAME),

	send_script_salle(CADRE,DOM,SDOM,SUJET,NAME,LEVEL,SOBRIQUET),
		
	path_doc(PATH_DOC),!,

	write("</HEAD>\n"),

	write_fset_row("*,25",0),
	send_frame_salle31(PATH_DOC,CADRE,DOM,SDOM,SUJET,NAME,LEVEL,SOBRIQUET),
%        write_frame(PATH_DOC,"frise.htm","frise",0),  oter le scrollbar
        write_frame(PATH_DOC,"frise.htm","frise",0),
	
	write_fset_end(),
	write("</HTML>").

% interface 1
  send_frame_salle31(PATH_DOC,CADRE,DOM,SDOM,SUJET,NAME,_LEVEL,_SOBRIQUET) :-
	get_interface(CADRE,DOM,SDOM,SUJET,1,DIM1,DIM2,DIM3),!,
%	entete_http(),
%	begin_entete_frame(NAME),
	
%	send_script_salle(CADRE,DOM,SDOM,SUJET,NAME,LEVEL,SOBRIQUET),
		
%	path_doc(PATH_DOC),!,

%	write("</HEAD>\n"),	
	write_fset_row(DIM1,0),
	make_url(NAME,URL),

	write_fset_col(DIM2,0),
  	  write_frame(PATH_DOC,"next.htm","next",0),
	  write_frame1(URL,"texte",0), 
	write_fset_end(),
  	  write_frame(PATH_DOC,"note.htm","note",0),
	write_fset_col(DIM3,0),
 	  write_frame(PATH_DOC,"navi.htm","navi",0), 
	  write_frame(PATH_DOC,"liens.htm","liens",0),
	write_fset_end(),
	write_fset_end().

%	write("</HTML>").

% interface 2
  send_frame_salle31(PATH_DOC,CADRE,DOM,SDOM,SUJET,NAME,_LEVEL,_SOBRIQUET) :-
	get_interface(CADRE,DOM,SDOM,SUJET,2,DIM1,DIM2,DIM3),!,
%	entete_http(),
%	begin_entete_frame(NAME),

%	send_script_salle(CADRE,DOM,SDOM,SUJET,NAME,LEVEL),

%	path_doc(PATH_DOC),!,

%	write("</HEAD>\n"),	
	write_fset_row(DIM1,0),
	make_url(NAME,URL),

	write_fset_col(DIM2,0),
	  write_frame1(URL,"texte",0), 
  	  write_frame(PATH_DOC,"note.htm","note",0),
	write_fset_end(),
  	  write_frame(PATH_DOC,"next.htm","next",0),
	write_fset_col(DIM3,0),
 	  write_frame(PATH_DOC,"navi.htm","navi",0), 
	  write_frame(PATH_DOC,"liens.htm","liens",0),
	write_fset_end(),
	write_fset_end().

%	write("</HTML>").
		
% interface 3
  send_frame_salle31(PATH_DOC,CADRE,DOM,SDOM,SUJET,NAME,_LEVEL,_SOBRIQUET) :-
	get_interface(CADRE,DOM,SDOM,SUJET,3,DIM1,DIM2,_),!,
%	entete_http(),
%	begin_entete_frame(NAME),

%	send_script_salle(CADRE,DOM,SDOM,SUJET,NAME,LEVEL),

%	path_doc(PATH_DOC),!,

%	write("</HEAD>\n"),	
	write_fset_row(DIM1,0),
	make_url(NAME,URL),
	  write_frame1(URL,"texte",0), 
  	  write_frame(PATH_DOC,"note.htm","note",0),
 	  write_fset_col(DIM2,0),
	    write_frame(PATH_DOC,"navi.htm","navi",0), 
 	    write_frame(PATH_DOC,"next.htm","next",0),
	    write_frame(PATH_DOC,"liens.htm","liens",0),
	write_fset_end(),
	write_fset_end().

%	write("</HTML>").

% interface 4
  send_frame_salle31(PATH_DOC,CADRE,DOM,SDOM,SUJET,NAME,_LEVEL,_SOBRIQUET) :-
	get_interface(CADRE,DOM,SDOM,SUJET,4,DIM1,DIM2,DIM3),!,
%	entete_http(),
%	begin_entete_frame(NAME),

%	send_script_salle(CADRE,DOM,SDOM,SUJET,NAME,LEVEL),

%	path_doc(PATH_DOC),!,

%	write("</HEAD>\n"),	
	write_fset_row(DIM1,0),
	make_url(NAME,URL),
 	  write_fset_col(DIM2,0),
	    write_frame1(URL,"texte",0), 
  	    write_frame(PATH_DOC,"note.htm","note",0),
	  write_fset_end(),
	  write_fset_col(DIM3,0),
	    write_frame(PATH_DOC,"navi.htm","navi",0), 
 	    write_frame(PATH_DOC,"next.htm","next",0),
	    write_frame(PATH_DOC,"liens.htm","liens",0),
	write_fset_end(),
	write_fset_end().

%	write("</HTML>").
	
% interface 5
  send_frame_salle31(PATH_DOC,CADRE,DOM,SDOM,SUJET,NAME,_LEVEL,_SOBRIQUET) :-
	get_interface(CADRE,DOM,SDOM,SUJET,5,DIM1,DIM2,DIM3),!,
%	entete_http(),
%	begin_entete_frame(NAME),

%	send_script_salle(CADRE,DOM,SDOM,SUJET,NAME,LEVEL),

%	path_doc(PATH_DOC),!,

%	write("</HEAD>\n"),	
	write_fset_col(DIM1,0),
	make_url(NAME,URL),
 	  write_fset_row(DIM2,0),
 	    write_frame(PATH_DOC,"next.htm","next",0),
	    write_frame(PATH_DOC,"navi.htm","navi",0), 
	  write_fset_end(),
 	  write_fset_row(DIM3,0),
	    write_frame1(URL,"texte",0), 
  	    write_frame(PATH_DOC,"note.htm","note",0),
	    write_frame(PATH_DOC,"liens.htm","liens",0),
	  write_fset_end(),
	write_fset_end().

%	write("</HTML>").

% interface 6
  send_frame_salle31(PATH_DOC,CADRE,DOM,SDOM,SUJET,NAME,_LEVEL,_SOBRIQUET) :-
	get_interface(CADRE,DOM,SDOM,SUJET,6,DIM1,DIM2,DIM3),!,

	write_fset_col(DIM1,0),
	make_url(NAME,URL),
 	  write_fset_row(DIM2,0),
	    write_frame1(URL,"texte",0), 
 	    write_frame(PATH_DOC,"next.htm","next",0),
	    write_frame(PATH_DOC,"navi.htm","navi",0), 
	  write_fset_end(),
 	  write_fset_row(DIM3,0),
  	    write_frame(PATH_DOC,"note.htm","note",0),
	    write_frame(PATH_DOC,"liens.htm","liens",0),
	  write_fset_end(),
	write_fset_end().	

% interface 7
  send_frame_salle31(PATH_DOC,CADRE,DOM,SDOM,SUJET,NAME,_LEVEL,_SOBRIQUET) :-
	get_interface(CADRE,DOM,SDOM,SUJET,7,DIM1,DIM2,DIM3),!,

	write_fset_col(DIM1,0),
	make_url(NAME,URL),
 	  write_fset_row(DIM2,0),
	    write_frame(PATH_DOC,"liens.htm","liens",0),
 	    write_frame(PATH_DOC,"next.htm","next",0),
	    write_frame(PATH_DOC,"navi.htm","navi",0), 
	  write_fset_end(),
 	  write_fset_row(DIM3,0),
	    write_frame1(URL,"texte",0), 
  	    write_frame(PATH_DOC,"note.htm","note",0),
	  write_fset_end(),
	write_fset_end().

% interface 8
  send_frame_salle31(PATH_DOC,CADRE,DOM,SDOM,SUJET,NAME,_LEVEL,_SOBRIQUET) :-
	get_interface(CADRE,DOM,SDOM,SUJET,8,DIM1,DIM2,DIM3),!,

	write_fset_col(DIM1,0),
	make_url(NAME,URL),
 	  write_fset_row(DIM2,0),
	    write_frame1(URL,"texte",0), 
 	    write_frame(PATH_DOC,"navi.htm","navi",0), 
	  write_fset_end(),
 	  write_fset_row(DIM3,0),
 	    write_frame(PATH_DOC,"note.htm","note",0),
	    write_frame(PATH_DOC,"liens.htm","liens",0),
 	    write_frame(PATH_DOC,"next.htm","next",0),
	  write_fset_end(),
	write_fset_end().
	
% interface 9
  send_frame_salle31(PATH_DOC,CADRE,DOM,SDOM,SUJET,NAME,_LEVEL,_SOBRIQUET) :-
	get_interface(CADRE,DOM,SDOM,SUJET,9,DIM1,_DIM2,DIM3),!,

	write_fset_col(DIM1,0),
	make_url(NAME,URL),
	  write_frame1(URL,"texte",0), 
 	  write_fset_row(DIM3,0),
 	    write_frame(PATH_DOC,"note.htm","note",0),
	    write_frame(PATH_DOC,"liens.htm","liens",0),
 	    write_frame(PATH_DOC,"next.htm","next",0),
 	    write_frame(PATH_DOC,"navi.htm","navi",0), 
	  write_fset_end(),
	write_fset_end().

% interface 10
  send_frame_salle31(PATH_DOC,CADRE,DOM,SDOM,SUJET,NAME,_LEVEL,_SOBRIQUET) :-
	get_interface(CADRE,DOM,SDOM,SUJET,10,DIM1,DIM2,DIM3),!,

	write_fset_col(DIM1,0),
	make_url(NAME,URL),
 	  write_fset_row(DIM2,0),
	    write_frame1(URL,"texte",0), 
  	    write_frame(PATH_DOC,"note.htm","note",0),
	  write_fset_end(),
 	  write_fset_row(DIM3,0),
	    write_frame(PATH_DOC,"liens.htm","liens",0),
 	    write_frame(PATH_DOC,"next.htm","next",0),
	    write_frame(PATH_DOC,"navi.htm","navi",0), 
	  write_fset_end(),
	write_fset_end().
	
% default 0
  send_frame_salle31(PATH_DOC,CADRE,DOM,SDOM,SUJET,NAME,_LEVEL,_SOBRIQUET) :-
	get_interface(CADRE,DOM,SDOM,SUJET,0,DIM1,DIM2,DIM3),!,
%	entete_http(),
%	begin_entete_frame(NAME),

%	send_script_salle(CADRE,DOM,SDOM,SUJET,NAME,LEVEL),
		
%	path_doc(PATH_DOC),!,

%	write("</HEAD>\n"),	
	write_fset_row(DIM1,0),
	make_url(NAME,URL),
	  write_frame1(URL,"texte",0), 
	write_fset_col(DIM2,0),
  	  write_frame(PATH_DOC,"next.htm","next",0),
  	  write_frame(PATH_DOC,"note.htm","note",0),
	write_fset_end(),
	write_fset_col(DIM3,0),
 	  write_frame(PATH_DOC,"navi.htm","navi",0), 
	  write_frame(PATH_DOC,"liens.htm","liens",0),
	write_fset_end(),
	write_fset_end().

%	write("</HTML>").

  send_script_salle(CADRE,DOM,SDOM,SUJET,NAME,LEVEL,SOB) :-
	write("<SCRIPT LANGUAGE=\"JavaScript1.2\">\n"),

	% ajuster le variables globales
	% (cas du passage direct d'une salle  l'autre
	
	format(VAR1,"parent.wxPartie    = \"%\" ;\n",CADRE),
	format(VAR2,"parent.wxFloor     = % ;\n",DOM),
	format(VAR3,"parent.wxZone      = % ;\n",SDOM),
	format(VAR4,"parent.wxSalle     = % ;\n",SUJET),
	VAR5 = "parent.wxCurrentUi = \"\" ;\n",
	write(VAR1,VAR2,VAR3,VAR4,VAR5),nl,

	% table d'adjacence (salles)
        write("var ind_adj = 0 ;\n"),
	write("var tabAdj = new Array(0) ;\n"),

        make_adj_list(CADRE,DOM,SDOM,SUJET,LEVEL,SOB),
	write("var ptTabAdj = ind_adj ; \n"),

	% table des activits dans la mme salle (  afficher)
        write("var ind_adj = 0 ;\n"),
	write("var tabActAdj = new Array(0) ;\n"),
	make_adj_act(CADRE,DOM,SDOM,SUJET,NAME,LEVEL),
	write("var ptTabActAdj = ind_adj ; \n"),

	% table de toutes les activits de la mme salle
        write("var ind_act = 0 ;\n"),
	write("var tabAct = new Array(0) ;\n"),
	make_act_all(CADRE,DOM,SDOM,SUJET,NAME,LEVEL),
	write("var ptTabAct = ind_act ; \n"),
	
        
	bool_sortie(CADRE,DOM,SDOM,SUJET,BOOL),
	write("var existsortie = ",BOOL," ;\n"),
		
  	path_img(PIMG),
	path_src(PATH),!,
	format(FILE,"%/salle.jx",PATH),
	file_str(FILE,JVS),	
	write(JVS),

	get_sujet1(CADRE,DOM,SDOM,LEVEL,_NOM,TITRE,SUJET,_LEV1),
  	choix_frise(CADRE,DOM,SDOM,"E",LEVEL,FRISE,COLOR),

	writef("\nfunction affFrise() {\n  afficheFrise('%/%','color: %; margin-left: 20px',\"%\")\n}\n",PIMG,FRISE,COLOR,TITRE),
	write("</SCRIPT>\n").

  get_interface(CADRE,DOM,SDOM,SUJET,N,DIM1,DIM2,DIM3) :-
	interface(CADRE,DOM,SDOM,SUJET,N,DIM1,DIM2,DIM3),!.
  get_interface(_,_,_,_,0,"60%,20%,*","25%,*","50%,*").

  make_adj_list(CADRE,DOM,SDOM,SUJET,LEVEL,SOB) :-
        adj_list(CADRE,DOM,SDOM,SUJET,LEVEL,SOB,CADRE1,DOM1,SDOM1,SUJET1,TITRE),
        writef("tabAdj[ind_adj++] = new salleAdj(\"%\",%,%,%,\"%\",\"%\");\n",CADRE1,DOM1,SDOM1,SUJET1,"",TITRE),
        fail.
  make_adj_list(_,_,_,_,_,_).
/*
  make_adj_list(CADRE,DOM,SDOM,SUJET,LEVEL) :-
	adjacent(CADRE,DOM,SDOM,SUJET,CADRE1,DOM1,SDOM1,SUJET1),
  	get_sujet1(CADRE1,DOM1,SDOM1,LEVEL,_NAME,TITRE,SUJET1,_),
	writef("tabAdj[ind_adj++] = new salleAdj(\"%\",%,%,%,\"%\",\"%\");\n",CADRE1,DOM1,SDOM1,SUJET1,"",TITRE),
	fail.
  make_adj_list(CADRE,DOM,SDOM,SUJET,LEVEL) :-
	adjacent(CADRE1,DOM1,SDOM1,SUJET1,CADRE,DOM,SDOM,SUJET),
  	get_sujet1(CADRE1,DOM1,SDOM1,LEVEL,_NAME,TITRE,SUJET1,_LEV1),
	writef("tabAdj[ind_adj++] = new salleAdj(\"%\",%,%,%,\"%\",\"%\");\n",CADRE1,DOM1,SDOM1,SUJET1,"",TITRE),
	fail.
  make_adj_list(_,_,_,_,_).
*/
  make_adj_act(CADRE,DOM,SDOM,SUJET,_NAME,LEV) :-
 	get_ui(1,PACK,FILE,NAME1,TITRE,CADRE,DOM,SDOM,SUJET,TYPE,LEV,LEV1),
% 	NAME1<>NAME,
% problme du target = texte ( default)
	writef("tabActAdj[ind_adj++] = new parent.wxLinkObj(\"%\",\"\",\"%\",\"%\",\"%/%\",\"texte\",\"next\",\"%\",0);\n",TYPE,NAME1,TITRE,PACK,FILE,LEV1),
	fail.
  make_adj_act(_,_,_,_,_,_).

  make_act_all(CADRE,DOM,SDOM,SUJET,_NAME,LEV) :-
 	get_ui(_,_PACK,_FILE,NAME1,_TITRE,CADRE,DOM,SDOM,SUJET,_TYPE,LEV,_LEV1),
% 	NAME1<>NAME,
% problme du target = texte ( default)
	writef("tabAct[ind_act++] = \"%\" ;\n",NAME1),
	fail.
  make_act_all(_,_,_,_,_,_).
    
  make_url(NAME,URL) :-
  % la demande est sur le nom on peut refuser une visibilit 0 !  	
 	ui(_,PACK,FILE,NAME,_TITRE,_CADRE,_DOM,_SDOM,_SUJET,_TYPE,_LEVEL,_),
/*
 	inst_ui(1,NAME,_TITRE,_CADRE,_DOM,_SDOM,_SUJET,_TYPE,_LEVEL,_),
 	ui(PACK,FILE,NAME,_TITRE,_TYPE,_LEVEL),
*/
 	searchstring(FILE,".xml",_),
 	path_xml(PATH),!,
	format(URL,"%/%/%",PATH,PACK,FILE).
  make_url(NAME,URL) :-  	
 	ui(1,PACK,FILE,NAME,_TITRE,_CADRE,_DOM,_SDOM,_SUJET,_TYPE,_LEVEL,_),
/* 	inst_ui(1,NAME,_TITRE,_CADRE,_DOM,_SDOM,_SUJET,_TYPE,_LEVEL,_),
 	ui(PACK,FILE,NAME,_TITRE,_TYPE,_LEVEL), */
 	path_doc(PATH),!,
	format(URL,"%/%/%",PATH,PACK,FILE).
	
  bool_sortie(CADRE,DOM,SDOM,SUJET,"true") :- 
  	existsortie(CADRE,DOM,SDOM,SUJET),!.
  bool_sortie(_CADRE,_DOM,_SDOM,_SUJET,"false"). 

  first_activity(CADRE,DOM,SDOM,SUJET,LEVEL,NAME,LEV1) :-
	get_ui(1,_PACK,_FILE,NAME,_TITRE,CADRE,DOM,SDOM,SUJET,_TYPE,LEVEL,LEV1),
	concat("index",_,NAME),!. % NAME commence par index
  first_activity(CADRE,DOM,SDOM,SUJET,LEVEL,NAME,LEV1) :-
	get_ui(1,_PACK,_FILE,NAME,_TITRE,CADRE,DOM,SDOM,SUJET,_TYPE,LEVEL,LEV1),!.

  adj_list(CADRE,DOM,SDOM,SUJET,LEVEL,SOB,CADRE1,DOM1,SDOM1,SUJET1,TITRE) :-
        adjacent(CADRE,DOM,SDOM,SUJET,CADRE1,DOM1,SDOM1,SUJET1),
        control_restriction_salle(CADRE1,DOM1,SDOM1,SUJET1,SOB),
        get_sujet1(CADRE1,DOM1,SDOM1,LEVEL,_NAME,TITRE,SUJET1,_).
  adj_list(CADRE,DOM,SDOM,SUJET,LEVEL,SOB,CADRE1,DOM1,SDOM1,SUJET1,TITRE) :-
        adjacent(CADRE1,DOM1,SDOM1,SUJET1,CADRE,DOM,SDOM,SUJET),
        control_restriction_salle(CADRE1,DOM1,SDOM1,SUJET1,SOB),
        get_sujet1(CADRE1,DOM1,SDOM1,LEVEL,_NAME,TITRE,SUJET1,_LEV1).