% envoi du teleporteur

PREDICATES
  affiche_cadre(INTEGER,STRING)
  affiche_domaine(STRING,INTEGER,STRING)
  affiche_sdomaine(STRING,INTEGER,INTEGER,STRING)
  affiche_sujet(STRING,INTEGER,INTEGER,INTEGER,STRING)
/*  
  hay_salida(STRING,INTEGER,INTEGER,INTEGER,STRING)
  hay_domaine(STRING,INTEGER)
  hay_sdomaine(STRING,INTEGER,INTEGER)
  hay_sujet(STRING,INTEGER,INTEGER,INTEGER)
  hay_activite(STRING,INTEGER,INTEGER,INTEGER,INTEGER)
*/

CLAUSES
  send_frame_telep(LEVEL,SOBRIQUET) :-
	entete_http(),
  	path_img(PIMG),!,
	make_link("partie","hall",0,0,-1,"N","Hall","Hall","N",1,LEVEL,SOBRIQUET,"?",LEVEL,LINK),
	begin_entete("teleporteur"),
	write("<SCRIPT LANGUAGE='JavaScript'>\n"),
	write("function hide_status(msg) {\n  return parent.hide_status(msg) ;\n}\n"),
	write("</SCRIPT></HEAD>\n"),
	write("<BODY>\n"), 
	write("<TABLE WIDTH='100%'>\n"),
	write("<TR BGCOLOR='#99FFFF'><TD WIDTH='109'>&nbsp;</TD><TD COLSPAN='2'><H3>",LINK,"</H3></TD></TR>\n"),
	format(LIGNE1,"<TR><TD WIDTH='109' BACKGROUND='%/special_3.gif'>&nbsp;</TD><TD BACKGROUND='%/fonds/fond_texte.gif'>\n",PIMG,PIMG),
	write(LIGNE1),
	affiche_cadre(LEVEL,SOBRIQUET),
	format(LIGNE2,"</TD><TD WIDTH='109' BACKGROUND='%/special_4.gif'>&nbsp;</TD></TR>\n",PIMG),
	write(LIGNE2),
	write("<TR BGCOLOR='#99FFFF'><TD WIDTH='109'>&nbsp;</TD><TD COLSPAN='3'><H3>",LINK,"</H3></TD></TR>"),
	write("</TABLE>\n</BODY>\n</HTML>").

  affiche_cadre(LEVEL,SOB) :-
	cadre(NOM,_,TITRE,_CODE),
	hay_domaine(NOM,LEVEL,SOB),
%	writef("<H3>Cadre: % (%/%)</H3>\n",TITRE,NOM,CODE),
	writef("<H3>Cadre: %</H3>\n",TITRE),
	affiche_domaine(NOM,LEVEL,SOB),
	fail.
  affiche_cadre(_,_).

  affiche_domaine(CADRE,LEVEL,SOB) :-
	get_domaine(CADRE,LEVEL,_NOM,TITRE,CODE,LEV1),
	hay_sdomaine(CADRE,CODE,LEVEL,SOB),
%	writef("<H4>Domaine: % (%/%) level %</H4>\n",TITRE,NOM,CODE,LEV1),
	writef("<H4>Domaine: % (%)</H4>\n",TITRE,LEV1),
	write("<DL>\n"),
	affiche_sdomaine(CADRE,CODE,LEVEL,SOB),
  	write("</DL>"),
	fail.
  affiche_domaine(_,_,_).

  affiche_sdomaine(CADRE,DOM,LEVEL,SOB) :-
	get_sdomaine(CADRE,DOM,LEVEL,_NOM,TITRE,CODE,LEV1),
	control_restriction_zone(CADRE,DOM,CODE,SOB),
	hay_sujet(CADRE,DOM,CODE,LEVEL,SOB),
%	writef("<DT>Sous-domaine: % (%/%) level %</DT>\n",TITRE,NOM,CODE,LEV1),
	writef("<DT>Sous-domaine: % (%)</DT>\n",TITRE,LEV1),
	write("<DD>"),
	affiche_sujet(CADRE,DOM,CODE,LEVEL,SOB),
	write("</DD>\n"),
	fail.
  affiche_sdomaine(_,_,_,_).

  affiche_sujet(CADRE,DOM,SDOM,LEVEL,SOB) :-
	get_sujet(CADRE,DOM,SDOM,LEVEL,_NOM,TITRE,CODE,LEV1),
	control_restriction_salle(CADRE,DOM,SDOM,CODE,SOB),
	hay_activite(CADRE,DOM,SDOM,CODE,LEVEL),
	make_link("salle",CADRE,DOM,SDOM,CODE,"",TITRE,"","",1,LEVEL,SOB,"porte",LEV1,LINK),
	hay_salida(CADRE,DOM,SDOM,CODE,IMG),
	write(IMG,LINK,"<BR>\n"),
	fail.
  affiche_sujet(_,_,_,_,_).

  hay_salida(CADRE,DOM,SDOM,CODE,IMG) :-
	existsortie(CADRE,DOM,SDOM,CODE),
  	path_server(SERV),!,
  	format(IMG,"<IMG SRC='%/images/fonds/picto_sortir.gif'> ",SERV).
  hay_salida(_,_,_,_,IMG) :-
  	path_server(SERV),!,
  	format(IMG,"<IMG SRC='%/images/fonds/picto_retour.gif'> ",SERV).

  hay_domaine(NOM,LEVEL,SOB) :-
	domaine(NOM,LEV,_,_,DOM),
	LEV<=LEVEL,
	hay_sdomaine(NOM,DOM,LEVEL,SOB),!.

  hay_sdomaine(NOM,DOM,LEVEL,SOB) :-
  	sdomaine(NOM,DOM,LEV,_,_,SDOM),
	control_restriction_zone(NOM,DOM,SDOM,SOB),
	LEV<=LEVEL,
	hay_sujet(NOM,DOM,SDOM,LEVEL,SOB),!.

  hay_sujet(NOM,DOM,SDOM,LEVEL,SOB) :-
	sujet(NOM,DOM,SDOM,LEV,_,_,SUJET),
	control_restriction_salle(NOM,DOM,SDOM,SUJET,SOB),
	LEV<=LEVEL,
	hay_activite(NOM,DOM,SDOM,SUJET,LEVEL),!.

  hay_sujet_open(NOM,DOM,SDOM,LEVEL,SOB) :-
	sujet(NOM,DOM,SDOM,LEV,_,_,SUJET),
	control_restriction_salle(NOM,DOM,SDOM,SUJET,SOB),
	LEV<=LEVEL,
	existsortie(NOM,DOM,SDOM,SUJET),
	hay_activite(NOM,DOM,SDOM,SUJET,LEVEL),!.


  hay_activite(NOM,DOM,SDOM,SUJ,LEVEL) :-
	ui(_,_,_,_,_,NOM,DOM,SDOM,SUJ,_,LEV,_),
	LEV<=LEVEL,!.

% ui(1,"rmt","f1214-s01.xml","f1214-s01","Bordures","fict",1,2,1,"situation",4,2)

% LOP190304
  control_restriction_salle(CADRE,DOM,SDOM,SUJET,SOB) :-
        control_restriction_zone(CADRE,DOM,SDOM,SOB),
	not(salle_restricted_to(CADRE,DOM,SDOM,SUJET,_)),!.
  control_restriction_salle(CADRE,DOM,SDOM,SUJET,SOB) :-
        control_restriction_zone(CADRE,DOM,SDOM,SOB),
        salle_restricted_to(CADRE,DOM,SDOM,SUJET,GROUPE),
        load_profil(SOB),
        profil(SOB,GROUPE,_,_,_),!.

  control_restriction_zone(CADRE,DOM,SDOM,_SOB) :-
        not(zone_restricted_to(CADRE,DOM,SDOM,_)),!.
  control_restriction_zone(CADRE,DOM,SDOM,SOB) :-
        zone_restricted_to(CADRE,DOM,SDOM,GROUPE),
        load_profil(SOB),
        profil(SOB,GROUPE,_,_,_),!.